package com.ruoyi.adsdesk.config.web;

import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.ruoyi.adsdesk.util.AdsPageUtil;
import com.ruoyi.common.core.domain.AjaxResult;
import lombok.extern.slf4j.Slf4j;
import org.jetbrains.annotations.NotNull;
import org.springframework.core.MethodParameter;
import org.springframework.http.MediaType;
import org.springframework.http.converter.HttpMessageConverter;
import org.springframework.http.server.ServerHttpRequest;
import org.springframework.http.server.ServerHttpResponse;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.servlet.mvc.method.annotation.ResponseBodyAdvice;

/**
 * 全局响应处理器
 * 由于Ads编码风格和若依略有不同, 为复用前端逻辑, 在此做下转换处理
 * @author Xingbz
 * 007 06-07
 */
@Slf4j
@ControllerAdvice("com.ruoyi.adsdesk.controller")
public class GlobalResponseBodyHandler implements ResponseBodyAdvice<Object> {

    @Override
    public boolean supports(@NotNull MethodParameter returnType, @NotNull Class<? extends HttpMessageConverter<?>> converterType) {
        // Class<?> returnClass = Optional.ofNullable(returnType.getMethod()).map(Method::getReturnType).orElse(null);
        // return Objects.nonNull(returnClass) && Objects.equals(returnClass, IPage.class);
        return true;
    }

    @Override
    public Object beforeBodyWrite(Object body, @NotNull MethodParameter returnType, @NotNull MediaType selectedContentType, @NotNull Class<? extends HttpMessageConverter<?>> selectedConverterType, @NotNull ServerHttpRequest request, @NotNull ServerHttpResponse response) {
        if (body instanceof AjaxResult) {
            return body;
        }

        if (body instanceof IPage) {
            return AdsPageUtil.transformToTableData((IPage<?>)body);
        }

        // String需要特殊处理, 否则会抛出java.lang.ClassCastException
        if (body instanceof String) {
            return JSON.toJSONString(AjaxResult.success(body));
        }

        return AjaxResult.success(body);
    }
}
