package com.ruoyi.adsdesk.controller.operation;

import com.ruoyi.adsdesk.business.operation.AdsSimulateLoginBusiness;
import com.ruoyi.adsdesk.param.SimulateLoginParam;
import com.ruoyi.framework.aspectj.lang.annotation.Log;
import com.ruoyi.framework.aspectj.lang.enums.BusinessType;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * 模拟登录控制
 * @author Xingbz
 * 2022-08-12
 */
@RestController
@RequestMapping("/adsdesk/simulate_login")
public class AdsSimulateLoginController {

    @Resource
    private AdsSimulateLoginBusiness simulateLoginBusiness;

    @Log(title = "模拟登录", businessType = BusinessType.ROOT)
    @PreAuthorize("@ss.hasPermi('operation:simulateLogin:query')")
    @PostMapping("/get")
    public String querySimulateLoginAuthToken(@RequestBody SimulateLoginParam param) {
        return simulateLoginBusiness.querySimulateLoginAuthToken(param);
    }
}
